/* File: filehelp.c */

/*-----------------------------------------------------------------**
** Copyright (C) The Higher Education Statistics Agency 1994,1995  **
** Authors:                                                        **
** 	Duncan Charlton: DuncanC@hesa.ac.uk                            **
** 	Adrian Crossley: AdrianC@hesa.ac.uk                            **
** 	John Turner    :   JohnT@hesa.ac.uk                            **
**-----------------------------------------------------------------*/


#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "vldtn.h"
#include "helper.h"
#include "vmacros.h"

					
struct FLD stValids[]={
	{1,"Abbrev",2,16,0,0,NULL,NULL,0,0,NULL,0},
	{2,"Code",2,16,0,0,NULL,NULL,0,0,NULL,0},
	{2,"Desc",2,255,0,0,NULL,NULL,0,0,NULL,0}
	};
	
struct FLD fldJACSCODEDummy={0,"Abbrev",0,0,0,0,NULL,NULL,0,0,NULL,0};
struct FLD fldPOSTCODEDummy={0,"Abbrev",0,0,0,0,NULL,NULL,0,0,NULL,0};
struct FLD fldFECOLLEGEDummy={0,"Abbrev",0,0,0,0,NULL,NULL,0,0,NULL,0};
static char szAux[255];

unsigned int REALLOCUNIT=128;
extern UINT uiLineLength;

ULONG ulVMem=0;       
ULONG ulReAlloc=0;
ULONG ulECount=0;
char *psStrBlock=NULL;
UINT uiStrBlockSize=0;
struct RULE *prlRules=NULL;
unsigned ulRules;
FILE *pfErrors=NULL;

/* returns field count, fills up field structure with offsets*/
#ifdef ANSI                                                                
int GetLineOffsetsCSV (struct FLD *pfld,PSZ pszLine)
#else
int GetLineOffsetsCSV (pfld,pszLine)
struct FLD *pfld;
PSZ pszLine;
#endif
{
unsigned char quote='"';
unsigned char comma=',';
unsigned int uiCount=1;
unsigned int uiLineLen;

BOOL fInQuote=0;
PSZ szLineBufferStart=pszLine;
PSZ pszTmp;

uiLineLen=strlen(pszLine);

while (*pszLine && uiCount<uinFields)
	{
	if (*pszLine==quote && szLineBufferStart==pszLine)
		{
		(pfld+0)->uiOffset=1;
		*pszLine=0;
		fInQuote=1;                           
		}
	if (*pszLine==quote)
		{
		fInQuote ^=1;                 
		
		
		/* code added 13/10/95 Adrian Crossley                               */
		/* to prevent double quotes within fields by checking that character */ 
		/* following closing quote (if any) is a comma                       */
		if (!fInQuote && *(pszLine+1) && *(pszLine+1)!=comma && *(pszLine+1)!=0x0A && *(pszLine+1)!=0x0D)
			return -1;

		
		}
	if (*pszLine==comma && !fInQuote)
		{
		if (*(pszLine-1)==quote)
			{
			*(pszLine-1)=0;
			}
		if (*(pszLine+1)==quote)
			{
			*(pszLine+1)=0;
			fInQuote=1;
			*pszLine=0;                                                                           
			pszLine++;
			}
		
		*pszLine=0;

		if (uiCount<uinFields)
			{
			(pfld+uiCount)->uiOffset=(unsigned int)(pszLine-szLineBufferStart+1);
			if (uiCount==uinFields-1) {
				pszTmp=pszLine+1;
				if (strlen(pszTmp) && *(pszTmp+strlen(pszTmp)-1)=='"')
					*(pszTmp+strlen(pszTmp)-1)=0;					
				}
			
			/*printf("%s\n",pszLine+1);*/
			}
			
		uiCount++;
		}
	pszLine++;
	}
	
/*kill last quote if exists*/
/*if (uiCount==uinFields-1 && *(szLineBufferStart+uiLineLen-1)==quote)
	*(szLineBufferStart+uiLineLen-1)=0;
*/
	
return uiCount;

}
/* obselete*/
#ifdef ANSI
unsigned int GetLineOffsetsTSV (PSZ pszLine)
#else
unsigned int GetLineOffsetsTSV (pszLine)
PSZ pszLine;
#endif

{
unsigned char tab='\t';
unsigned int uiCount=1;
PSZ pszLineStart=pszLine;

while (*pszLine)
	{
	if (*pszLine==tab)
		{
		stFields[uiCount].uiOffset=(unsigned int)(pszLine-pszLineStart);
		uiCount++;
		*pszLine=0;
		}
	pszLine++;
	}
return uiCount;
}
    
/* 
	Fixed format file. 
	Got to strip trailing whitespace from fields
	returns field count, fills up field structure with offsets
	*/
	    
	    
#ifdef ANSI    
int GetLineOffsetsFIX(PSZ pszLine)
#else                                      
int GetLineOffsetsFIX(pszLine)
PSZ pszLine;
#endif
{
unsigned int uiCount=1;
PSZ pszLineScan=NULL;

for (uiCount=0;uiCount<uinFields;uiCount++) {
	
	pszLineScan=pszLine+stFields[uiCount].uiOffset+stFields[uiCount].uiLength-1;
	if(stFields[uiCount].uiOffset+stFields[uiCount].uiLength>uiLineLength) 
		break; 	
	while (isspace(*pszLineScan) && pszLineScan>=pszLine+stFields[uiCount].uiOffset) {
		*pszLineScan=0; 
		pszLineScan--;
		}   
	
	}              

return uiCount;


}                                                               
/* allocates memory for passed string 
returning pointer to allllocated memory*/

#ifdef ANSI
char *stralloc(const char *ps)
#else                   
char *stralloc(ps)
const char *ps;
#endif
{

	UINT uiLen;
	char *psR;
             
	uiLen=strlen(ps)+1;
             
	if (!psStrBlock ||
			uiStrBlockSize+uiLen>=sizeof(char)*REALLOCUNIT) {
		if ((psStrBlock=malloc(sizeof(char)*REALLOCUNIT))==NULL) {
			if (!PIPING)
				fprintf(stderr,"stralloc Failed allocating %u bytes.\n",sizeof(char)*REALLOCUNIT);
			ErrExit(IERR_MEMORY);                                                                           
			}
		uiStrBlockSize=0;		
		}	
	      
	strcpy(psR=(psStrBlock+uiStrBlockSize),ps);

	uiStrBlockSize+=uiLen;           
	
	*(psStrBlock+uiStrBlockSize-1)=0;

	sprintf(szMsgBuffer,"stralloc: %s",psR);
	ShowDiag(szMsgBuffer,9);	                      
      
	return psR;      
    
  
}
/* add a valid entry with exit clause on failue to allocate*/
			      
#ifdef ANSI                              
BOOL AddValidEntry(struct FLD *pFld,PSZ pszEntry)
#else
BOOL AddValidEntry(pFld,pszEntry)
struct FLD *pFld;
PSZ pszEntry;
#endif
{             

	if (!pFld->uinValid) {
		pFld->uinAlloc=REALLOCUNIT;
		if ((pFld->ppszValids=(char **)calloc(1,sizeof(char *)*pFld->uinAlloc))==NULL) {
			if (!PIPING)
				fprintf(stderr,"Failed allocating %u bytes.\n",sizeof(char *)*(pFld->uinAlloc));
			ErrExit(IERR_MEMORY);                                                   
			}
		/* fprintf(stdout,"Alloc %u Bytes\n",sizeof(char *)*REALLOCUNIT);*/
		}
	else {
		if (pFld->uinValid>=pFld->uinAlloc) {
			pFld->uinAlloc+=REALLOCUNIT;
			if ((pFld->ppszValids=(char **)realloc(pFld->ppszValids,sizeof(char *)*(pFld->uinAlloc)))==NULL) {
				if (!PIPING)
					fprintf(stderr,"Failed reallocating %u bytes.\n",sizeof(char *)*(pFld->uinAlloc));
				ErrExit(IERR_MEMORY);                                                                           
				}
			ulReAlloc++;
			/* fprintf(stdout,"Realloc %u Bytes\n",sizeof(char *)*(stFields[uiField].uinAlloc)); */
      }                 
    }                                       

	ulVMem+=sizeof(char *)+strlen(pszEntry);                                    
	ulECount++;
	pFld->ppszValids[pFld->uinValid]=stralloc(pszEntry);
	pFld->uinValid++;                                                       

	return 1;
}
								
/* gets all valid entries*/
#ifdef ANSI                                                                
BOOL ReadValidEntries(void)
#else                      
BOOL ReadValidEntries()
#endif
{
	FILE *pfValid;              
	UINT uiLastField=0;
	UINT uiField=0;
	PSZ     pszCode=NULL;   
			
	if ((pfValid=fopen(szValidFile,"r"))==NULL) {
		if (!PIPING)
			fprintf(stderr,"Can't open: %s\n",szValidFile);
		ErrExit(IERR_FINPUT); /* Can't open that */
		}
	
	if (!PIPING)	
		fprintf(stdout,"Loading Valid Entries\n");

	ulVMem=0;
	ulReAlloc=0;
	ulECount=0;
		 
	while (fgets(szLineBuffer,LBSIZE-1,pfValid)!=NULL) {                 
		GetLineOffsetsCSV(stValids,szLineBuffer);
		uiField=GetFieldNoFromAbbrev(szLineBuffer+stValids[0].uiOffset);
		pszCode=szLineBuffer+stValids[1].uiOffset;
		AddValidEntry(stFields+uiField,pszCode);
		if (uiField!=uiLastField) {
			/* fprintf(stdout,"\nField %03u",uiField); */
			uiLastField=uiField;
			}
		/* fprintf(stdout,".");                  */
		}
		      
  fclose(pfValid);                           
  
	for (uiField=0;uiField<uinFields;uiField++) {
		if (stFields[uiField].ppszValids)       {
			if ((stFields[uiField].ppszValids=(char **)realloc(stFields[uiField].ppszValids,sizeof(char *)*(stFields[uiField].uinValid)))==NULL) {
				if (!PIPING)
					fprintf(stderr,"Failed reallocating %u bytes on Cleanup.\n",sizeof(char *)*(stFields[uiField].uinValid));
				ErrExit(IERR_MEMORY);                                                                           
				}
			/* fprintf(stdout,"Adjusting Field %u\n",uiField); */
			}
		}
  
	if (!PIPING)
  	fprintf(stdout,"Finished Reading %lu Valid Entries.\nValid Entries need %lu bytes of memory. %lu Reallocations were made\n\n",ulECount,ulVMem,ulReAlloc);
				       
	return 1;                                      
		
}

	
/* gets jacs codes with memory failure exit*/		      
#ifdef ANSI                      
BOOL ReadJACSCODE(void)
#else                  
BOOL ReadJACSCODE()
#endif
{
	FILE *pfJACSCODE;              
	PSZ     pszCode=NULL;   
				
	if ((pfJACSCODE=fopen("jacscode.csv","r"))==NULL) {
		strcpy(szAux,szAuxPath);
		strcat(szAux,"jacscode.csv");
		if ((pfJACSCODE=fopen(szAux,"r"))==NULL) {
			if (!PIPING)
				fprintf(stderr,"Can't open: %s\n","jacscode.csv");
			ErrExit(IERR_FINPUT); /* Can't open that */      
			}
		}
	
	if (!PIPING)	
		fprintf(stdout,"Loading JACSCODEs\n");
	
	ulVMem=0;
	ulReAlloc=0;
	ulECount=0;
		 
	while (fgets(szLineBuffer,LBSIZE-1,pfJACSCODE)!=NULL) {                 
		GetLineOffsetsCSV(stValids,szLineBuffer);
		pszCode=szLineBuffer+stValids[1].uiOffset;
		AddValidEntry(&fldJACSCODEDummy,pszCode);
		}
		      
  fclose(pfJACSCODE);                           
  
  if ((fldJACSCODEDummy.ppszValids=(char **)realloc(fldJACSCODEDummy.ppszValids,sizeof(char *)*(fldJACSCODEDummy.uinValid)))==NULL) {
		if (!PIPING)
  		fprintf(stderr,"Failed reallocating %u bytes on Cleanup.\n",sizeof(char *)*(fldJACSCODEDummy.uinValid));;
  	ErrExit(IERR_MEMORY);
    }             

	if (!PIPING)
  	fprintf(stdout,"Finished Reading %lu JACSCODEs.\nJACSCODEs need %lu bytes of memory. %lu Reallocations were made\n\n",ulECount,ulVMem,ulReAlloc);
  
	return 1;                                      
	
}

/* gets post codes with memory failure exit*/		      
#ifdef ANSI
BOOL ReadPostCODE(void)
#else                  
BOOL ReadPostCODE()
#endif
{
	FILE *pfPOSTCODE;              
	PSZ pszCode=NULL;   

				
	if ((pfPOSTCODE=fopen("postcode.csv","r"))==NULL) {
		strcpy(szAux,szAuxPath);
		strcat(szAux,"postcode.csv");
		if ((pfPOSTCODE=fopen(szAux,"r"))==NULL) {
			if (!PIPING)
				fprintf(stderr,"Can't open: %s\n","postcode.csv");
			ErrExit(IERR_FINPUT); /* Can't open that */      
			}		
		}
	
	if (!PIPING)	
		fprintf(stdout,"Loading POSTCODEs\n");
	
	ulVMem=0;
	ulReAlloc=0;
	ulECount=0;
		 
	while (fgets(szLineBuffer,LBSIZE-1,pfPOSTCODE)!=NULL) {                 
		GetLineOffsetsCSV(stValids,szLineBuffer);
		pszCode=szLineBuffer+stValids[1].uiOffset;
		AddValidEntry(&fldPOSTCODEDummy,pszCode);
		}
		      
  fclose(pfPOSTCODE);                           

  if ((fldPOSTCODEDummy.ppszValids=(char **)realloc(fldPOSTCODEDummy.ppszValids,sizeof(char *)*(fldPOSTCODEDummy.uinValid)))==NULL)
		if (!PIPING)
  		fprintf(stderr,"Failed reallocating %u bytes on Cleanup.\n",sizeof(char *)*(fldPOSTCODEDummy.uinValid));;

  
	if (!PIPING)
  	fprintf(stdout,"Finished Reading %lu POSTCODEs.\nPOSTCODEs need %lu bytes of memory. %lu Reallocations were made\n\n",ulECount,ulVMem,ulReAlloc);
  
	return 1;                                      
	
}


  
  	/* runs through valid entry list of postcodes only */
#ifdef ANSI  
BOOL IsValidPostCode(const PSZ lps)
#else                        
BOOL IsValidPostCode(lps)
const PSZ lps;
#endif
{
	return _IsValidCode(&fldPOSTCODEDummy,lps);
}       

                                                      
  
#ifdef ANSI
BOOL IsValidJacsCode6(UINT uiFieldNo)
#else
BOOL IsValidJacsCode6(uiFieldNo)
UINT uiFieldNo;
#endif
{
	PSZ pszValue=NULL;
	
	/* MDE 02/04/03 - changed from GetFieldNoString . Also no longer uses ValidCodeType*/
	
	pszValue=GetField(uiFieldNo);
	
	/* MDE 14/04/03 - validate that data is left justified */
	
	if (strcmp(GetFieldNoStringMid(uiFieldNo,0,1)," ")==0)
		return 0;
	
	return (IsValidJacsCode(pszValue));
}  
                                                           
#ifdef ANSI
BOOL IsValidJacsCode6_AnyJust(UINT uiFieldNo)
#else
BOOL IsValidJacsCode6_AnyJust(uiFieldNo)
UINT uiFieldNo;
#endif
{
	PSZ pszValue=NULL;
	
	/* MDE 14/04/03 (new) validates JACS code but does not check left-justified */
	
	pszValue=GetField(uiFieldNo);
	
	return (IsValidJacsCode(pszValue));
}


/* tests for valid Jacscode by looking in items read from jacscode.csv */
#ifdef ANSI
BOOL IsValidJacsCode(const PSZ lps)
#else
BOOL IsValidJacsCode(lps)
const PSZ lps;
#endif
{                                                 
     return _IsValidCode(&fldJACSCODEDummy,lps);   
}   


#ifdef ANSI
BOOL IsValidMultiJacs(UINT uiFieldNo)
#else
BOOL IsValidMultiJacs(uiFieldNo)
UINT uiFieldNo;
#endif
{
	
	/* Data expected is 6 character alphanumeric in format CnnCnn or CnCnCn */
	/* where each part is a valid JACS code */
	
	int nIndex=0;	
	PSZ pszValue=NULL;
	static SZ szCode1[3];
	static SZ szCode2[3];
	static SZ szCode3[3];
	int isValid1=0;
	int isValid2=0;
	int isValid3=0;

	/* Get the data contained in the field including any chars beyond expected length*/
	pszValue=GetField(uiFieldNo);

	/* 7th character should be an end-of string */
	if (!(*(pszValue+6)==0))
	   return 0;
		 	

	if(isdigit(*(pszValue+2)))   /* 3rd char is a digit so format is CnnCnn */
		{
		   /* pick out 1st code, add a zero on the end followed by end-of-string marker*/
		   strncpy(szCode1,(pszValue),3);
		   *(szCode1+3)='0';
		   *(szCode1+4)=0;
		   if (IsValidJacsCode(szCode1) )
			   isValid1=1;
		   		   
		   /* pick out 2nd code ... */
		   strncpy(szCode2,(pszValue+3),3);
		   *(szCode2+3)='0';
		   *(szCode2+4)=0;
		   if (IsValidJacsCode(szCode2))
			   isValid2=1;
		   
		   return (isValid1 && isValid2);
		}
	else	  		  /* must be format CnCnCn */
		{
		   /* pick out 1st code, add two zeros on the end followed by end-of-string marker*/
		   strncpy(szCode1,(pszValue),2);
		   *(szCode1+2)='0';
		   *(szCode1+3)='0';
		   *(szCode1+4)=0;
		   if (IsValidJacsCode(szCode1))
			   isValid1=1;

		   /* pick out 2nd code ... */
		   strncpy(szCode2,(pszValue+2),2);
		   *(szCode2+2)='0';
		   *(szCode2+3)='0';
		   *(szCode2+4)=0;
		   if (IsValidJacsCode(szCode2))
			   isValid2=1;

		   /* pick out 3rd code ... */
		   strncpy(szCode3,(pszValue+4),2);
		   *(szCode3+2)='0';
		   *(szCode3+3)='0';
		   *(szCode3+4)=0;
		   if (IsValidJacsCode(szCode3))
			   isValid3=1;
		   
		   return (isValid1 && isValid2 && isValid3);
	}
}




#ifdef ANSI                     
unsigned long ReadUnorderedLong(void)
#else
unsigned long ReadUnorderedLong(void)
#endif
{
	unsigned long ulRead=0;
	unsigned char chByte;
	
	fread(&chByte,sizeof(char),1,pfErrors);                                            	
	ulRead=chByte*0x1000000;

	fread(&chByte,sizeof(char),1,pfErrors);                                            	
	ulRead+=chByte*0x10000;
	
	fread(&chByte,sizeof(char),1,pfErrors);                                            	
	ulRead+=chByte*0x100;
	
	fread(&chByte,sizeof(char),1,pfErrors);                                            	
	ulRead+=chByte*0x1;

	return ulRead;	                  
	                  
}

/* read short error text each is 32 bytes long*/		     
#ifdef ANSI                     
BOOL ReadErrorTable(void)
#else
BOOL ReadErrorTable()
#endif
{
	unsigned long ulCount;           
						    
	ulRules=(unsigned int)ReadUnorderedLong();
							    
	/* fread(&ulRules,sizeof(long),1,pfErrors); */
	
	if (!ulRules)
		return 1;
  
		if (!PIPING)
  		fprintf(stdout,"Loading %u Error Strings...",ulRules);
  
	if ((prlRules=(struct RULE *) calloc(ulRules,sizeof(struct RULE)))==NULL)
		ErrExit(IERR_MEMORY);                                                                           
		
	for (ulCount=0;ulCount<ulRules;ulCount++) {
						                
		prlRules[ulCount].ulRule=ReadUnorderedLong();
						                
		/* fread(&(prlRules[ulCount].ulRule),sizeof(ULONG),1,pfErrors); */
		prlRules[ulCount].ulOffset=ulRules*sizeof(unsigned long)+sizeof(unsigned long)+32*ulCount;
					
		}
	
	if (!PIPING)										 
		fprintf(stdout,"Done reading %lu strings.\n\n",prlRules[ulCount-1].ulRule);
  
	return 1;                                      
}                                    
/* gets the short error message for an error putting a default no error message if in verbose mode*/
#ifdef ANSI                    
PSZ GetErrorString(ULONG ulRule)
#else 
PSZ GetErrorString(ulRule)
ULONG ulRule;
#endif
{
	unsigned long ulCount;                     
	static char szError[40];                 
	static char *lps;
	
				
	*szError=0;                             
	
	if (!Options.bExplain)
		return szError;

	if (ulRule==65535) {
		strcpy(szError,"Data too long for field.");
		return szError;
		}
				
	for (ulCount=0;ulCount<ulRules;ulCount++) {
		if (prlRules[ulCount].ulRule==ulRule) {
	    
			fseek(pfErrors,prlRules[ulCount].ulOffset,SEEK_SET);
		    fread(szError,sizeof(char),32,pfErrors);                                            
		    *(szError+32)=0;
		    lps=szError;
		    while (*lps) {
		    	if (*lps=='%')
		    		*lps='%';	
				lps++;		    				    		
				}		    		
	    	return szError;
	        }
		}       

	if (!PIPING)
		sprintf(szError,"No error for %08lx           ",ulRule);
	return szError;         
}
/* returns pointer to string of a character repeated 2nd parameter times, used for outputting hashes*/
#ifdef ANSI
PSZ DuplicateChar(SZ szChar,UINT uiRep)
#else
PSZ DuplicateChar(szChar,uiRep)
SZ szChar;
UINT uiRep;                            
#endif
{  
   SZ static szBuffer[LBSIZE]; 
   UINT uiCount;

   for(uiCount=0;uiCount<uiRep;uiCount++)
        szBuffer[uiCount]=szChar;
   szBuffer[uiCount]=0;     
        
   return szBuffer;
}                                        

/* outputs data in internal  format whether csv or asc*/
#ifdef ANSI                              
BOOL OutputCleanField(UINT uiValResult,UINT uiFieldNo, FILE * pf)
#else
BOOL OutputCleanField(uiValResult,uiFieldNo,pf)
UNIT uiValResult;
UNIT uiFieldNo;
FILE * pf;
#endif
{                     
  #define ERRORCHAR '$'
  #define REDUCEDFILLER '#'	
  /* Oracle not recognizing all 9's so sub a regognizable date into derived data input*/
  char szUnknownDate[11]= {"99/99/9999"};
  char szSubForUnknownDate[11]= {"31/12/9999"};
  SZ  static szBuffer[LBSIZE];            
  if(!IsFieldRQD(uiFieldNo)){
	  strcpy(szBuffer,DuplicateChar(REDUCEDFILLER,stFields[uiFieldNo].uiLength));
	  fprintf(pf,"%s",szBuffer);     
	  return 1;
	  }

	/*HASH out non-december returnable fields*/
	if ( (M_DECEMBER) && (!stFields[uiFieldNo].uiDecember) ) {
		strcpy(szBuffer,DuplicateChar(REDUCEDFILLER,stFields[uiFieldNo].uiLength));
	  fprintf(pf,"%s",szBuffer);     
	  return 1;
	  }
		
 	if(!uiValResult){

	  if(stFields[uiFieldNo].uiType!=3)              
      strcpy(szBuffer,GetOutFieldNoString(uiFieldNo));
	     /* dates*/
    if(stFields[uiFieldNo].uiType==3) {
	  strcpy(szBuffer,GetFieldNoDate(uiFieldNo)); 
	  /* next 2 lines for oracle date substitution*/
      
      if(!strcmp(szBuffer,szUnknownDate))
	  	strcpy(szBuffer,szSubForUnknownDate);
       

    	if(!*szBuffer) 
    		strcpy(szBuffer,"          "); 
      }
    }   
   else 
   	strcpy(szBuffer,DuplicateChar(ERRORCHAR,stFields[uiFieldNo].uiLength));
     
    fprintf(pf,"%s",szBuffer);     
	return 1;
}	                                


#ifdef ANSI
BOOL ReadFEColleges(void)
#else                  
BOOL ReadFEColleges()
#endif
{
	FILE *pfFECollege;              
	PSZ pszCode=NULL;   

				
	if ((pfFECollege=fopen("fecolls.csv","r"))==NULL) {
		strcpy(szAux,szAuxPath);
		strcat(szAux,"fecolls.csv");
		if ((pfFECollege=fopen(szAux,"r"))==NULL) {
			if (!PIPING)
				fprintf(stderr,"Can't open: %s\n","fecolls.csv");
			ErrExit(IERR_FINPUT); /* Can't open file */      
			}		
		}
	
	if (!PIPING)	
		fprintf(stdout,"Loading FEColleges\n");
	
	ulVMem=0;
	ulReAlloc=0;
	ulECount=0;
		 
	while (fgets(szLineBuffer,LBSIZE-1,pfFECollege)!=NULL) {                 
		GetLineOffsetsCSV(stValids,szLineBuffer);
		pszCode=szLineBuffer+stValids[1].uiOffset;
		AddValidEntry(&fldFECOLLEGEDummy,pszCode);
		}
		      
  fclose(pfFECollege);                           

  if ((fldFECOLLEGEDummy.ppszValids=(char **)realloc(fldFECOLLEGEDummy.ppszValids,sizeof(char *)*(fldFECOLLEGEDummy.uinValid)))==NULL)
		if (!PIPING)
  		fprintf(stderr,"Failed reallocating %u bytes on Cleanup.\n",sizeof(char *)*(fldFECOLLEGEDummy.uinValid));;

  
	if (!PIPING)
  	fprintf(stdout,"Finished Reading %lu FEColleges.\nFEcolleges need %lu bytes of memory. %lu Reallocations were made\n\n",ulECount,ulVMem,ulReAlloc);
  
	return 1;                                      
	
}


  	/* runs through list of fe colleges as picked up from file */
#ifdef ANSI  
BOOL IsValidFECollege(const PSZ lps)
#else                        
BOOL IsValidFECollege(lps)
const PSZ lps;
#endif
{
	return _IsValidCode(&fldFECOLLEGEDummy,lps);
}       
