/* File: helper.c */

/*-----------------------------------------------------------------**
** Copyright (C) The Higher Education Statistics Agency 1994,1995  **
** Authors:                                                        **
** 	Duncan Charlton: DuncanC@hesa.ac.uk                            **
** 	Adrian Crossley: AdrianC@hesa.ac.uk                            **
** 	John Turner    :   JohnT@hesa.ac.uk                            **
**-----------------------------------------------------------------*/


#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "vldtn.h"
#include "helper.h"
extern int  Error_Count;
ULONG ulCurFieldInteger=0;
int WarningMessageDone=0;
PSZ pszCutFieldString=NULL;          
/*static int Warning_Totals[147];
static int Error_Totals[147];

/* MDE 2006-02-21 new declaration of RuleText and use in -u output. */
char RuleText[500];

struct clMonth {
	char szLName[16];
	char szSName[4];
	char days;
	};
  

struct clMonth rgMonths[]={{"January",	"Jan",		31},
						{"February",	"Feb",		28},
						{"March",		"Mar",		31},
						{"April",		"Apr",		30},
						{"May",			"May",		31},
						{"June",		"Jun",		30},
						{"July",		"Jul",		31},
						{"August",		"Aug",		31},
						{"September",	"Sep",		30},
						{"October",		"Oct",		31},
						{"November",	"Nov",		30},
						{"December",	"Dec",		31}
						};

struct HesaDate {
	UINT uiYear;
	UINT uiMonth;
	UINT uiDay;
	ULONG ulJulian; 
	};                         
 
#ifndef _MSC_VER
      
/* Put strcmpi in here for non-Bill compilers. */
/*

Many thanks to  Dave King of Bristol University. for
providing this version of strcmpi().


*/
#ifdef ANSI
int strcmpi(const char *r, const char *o)
#else
int strcmpi(r,o)
const char *r;
const char *o;
#endif
{
  if (r == NULL && o == NULL)
    return (0);
  if (o == NULL)
    return (1);
  if (r == NULL)
    return (-1);

  while (*o && *r && (isupper (*o) ? tolower (*o) : *o) ==
         (isupper (*r) ? tolower (*r) : *r))
    {
      o++, r++;
    }
  return ((isupper (*o) ? tolower (*o) : *o) - (isupper (*r) ? tolower (*r) :
*r));
}


/* And strdup */

#ifdef ANSI
char *strdup(const char *string)
#else
char *strdup(string)
char *string;
#endif
{
	PSZ psz;
	
	if ((psz=calloc(strlen(string)+1,sizeof(char)))==NULL)
		return NULL;
	
	strcpy(psz,string);
	
	return psz;
	
}

/* 
	and ltoa, this version doesn't implement the radix param,
	but we don't use it anyway.
	*/

#ifdef ANSI
char *ltoa(long value,char *string,int radix)
#else
char *ltoa(value,string,radix)
long value;
char *string;
int radix;
#endif
{
	sprintf(string,"%lu",value);
	return string;
}




#endif
/* show string dependant on diagnostic level set */
#ifdef ANSI
void ShowDiag(const char *lps,UINT uiLevel)
#else
void ShowDiag(lps,uiLevel)
char *lps;
UINT uiLevel;
#endif
{
	if (uiLevel<=Options.uiDiag)
		fprintf(stdout,"%s\n",lps);
}

/* get ,if it is a reduced return, whether  field is required from structure */
#ifdef ANSI
UINT IsFieldRQD(UINT uiFieldNo)
#else
UINT IsFieldRQD(uiFieldNo)
UINT uiFieldNo;
#endif
{   
	if (*(GetFieldNoString(0)+2)=='0')
		return 1;
	
	return stFields[uiFieldNo].pfRqd(0);
}  
/* get long error message */
#ifdef ANSI             
char *GetLongErrorMessage(UINT ErrorNumber)
#else 
char *GetLongErrorMessage(ErrorNumber)    
UINT ErrorNumber;
#endif
{   
		
		int MessageFound=0;
 		UINT num1;                               
 		char  ErrorNumStr[5];
 		/* fpos_t pos;    commented out, is not used anywhere. mde 2005-05-07 */
		int CommaCount=0,BufferIndex=0,StartPlace;

		/* ~ 2004-03-19 (ME) increased these from 256 to 600   */
		static char Buffer[600];  
		static char BufferReturn[600];

		/* ~  pos=0;  2004-04-15 (MDE) this line caused problem for one institution, though works on most platforms. */
		/* ~ fsetpos(pfExplanErr,&pos);		2004-04-15 (MDE)  */
		fseek( pfExplanErr, 0L, SEEK_SET); /* ~ 2004-04-15 (MDE) put this in instead to make sure it starts from beginning of file   */
		
		fgets(Buffer,1024,pfExplanErr);     /* get rid of header line  */
		while(!feof(pfExplanErr)){
			fgets(Buffer,1024,pfExplanErr); 
			sscanf(Buffer,"%u",&num1);      /*  loop through lines in error file until get to one with passed error number*/
			if(num1==ErrorNumber){
				MessageFound=1;
				break;
				};
			};
			if(!MessageFound){
				strcpy(BufferReturn,"Long Error Message not found for Rule ");   /* message if error description not found in file*/
				#ifdef ANSI  
				#else
					/* ~ this line caused problem for gcc ansi compiler */
					/* ~ don't think its needed anyway because SUMMARY file looks ok produced by ansi exe   */

					itoa(ErrorNumber,ErrorNumStr,10);  
				#endif
				
				if((int)ErrorNumber<999)
				strcat(BufferReturn,"0");
		  		strcat(BufferReturn,ErrorNumStr);  
				return BufferReturn;
				}
			while(CommaCount<4){
				if(Buffer[BufferIndex] == 44)	/* Comma =44 */
		       		CommaCount++;
				BufferIndex++;
			};
			BufferIndex++;
			StartPlace = BufferIndex;            
			while(Buffer[BufferIndex]!= '\n')
				BufferIndex++;               
			Buffer[BufferIndex-1]='\0';      			/*  -1 gets rid of last quote*/
			strcpy(BufferReturn,Buffer+StartPlace);
		
		return BufferReturn;
}

/* big function that calls field specific validation function and writes to error files if neccesary*/
#ifdef ANSI
UINT ValidateField(UINT uiFieldNo,struct ERROR *pstvErrors)
#else
UINT ValidateField(uiFieldNo,*pstvErrors)
UINT uiFieldNo;
struct ERROR *pstvErrors
#endif
{	
    UINT uiError;   
    int index=0;               			/* index into error structure */ 
	char szHUSID[17]; 
    char szCONTRACTID[21];
	char szTmp[128];
	char szOwnStu[64];
	char szOwnPsd[64];
    int iLen;
    char szDataTrunc[140];
    int bContract=0;

  /* ~	PSZ pszTmp;  */
	if (stFields[uiFieldNo].bIgnore && !Options.bNegate)
		return 0;

	if (!stFields[uiFieldNo].bIgnore && Options.bNegate)
		return 0;
      
	strncpy(szHUSID,GetFieldNoString(uiKeyField),16);
	/* *(szHUSID)=0; */
	*(szHUSID+16)=0;                    


    
    /* is it a staff contract record (type 26) ? */
    if (szLRNo[3]=='2' && szLRNo[4]=='6') {
        bContract=1;
        strncpy(szCONTRACTID,GetFieldNoString(4),20);
		*(szCONTRACTID+20)=0;
    }

	/* MDE 25/11/2002 if not fixed length then need to get data up to field marker */
	
	if(Options.uiType==TY_FIX)
    	{
    	   strcpy(szTmp,GetFieldNoString(uiFieldNo));
    	}
    	else
    	{
	   strncpy(szTmp,szLineBuffer+stFields[uiFieldNo].uiOffset,127);
	}
	
	

	if((szLRNo[4]=='1' || szLRNo[4]=='2') && szLRNo[3]=='1'){
		strcpy(szOwnStu,GetFieldNoString(OwnStuId));
		strcpy(szOwnPsd,GetFieldNoString(OwnPsdId));
		}
		else{
			strcpy(szOwnStu,"    ");
	    	strcpy(szOwnPsd,"    ");
		    }

/* ================ DO THE VALIDATION ================ */
		  
	uiError=stFields[uiFieldNo].pfVld();
 
/* ================ ACT AS APPROPRIATE ================ */

	/* 1. it is Aardvark mode and there has been an error or a warning... */
	if (Options.bPipe && uiSeverity) {

		/* output to screen */
		fprintf(pfError,"%011lu%011lu%-16s%03u%-8s%06u%04u%-40s\n",	
											ulConnection,
											ulCurRecordNo,
											szHUSID,											
											stFields[uiFieldNo].uiNo,
											stFields[uiFieldNo].szAbbrev,
											uiError,
											uiSeverity,
											szTmp);

		/* if severity >=10 then write to the .ERRORS file	2004-03-30 (MDE) */	    
        if(uiSeverity>=WARNINGLEVEL && uiError) {
            if (bContract) {
			    fprintf(pfError2,"%08lu %-16s %-20s %03u %-8s %06u %04u %s <%s>        %s        %s\n",ulCurRecordNo,szHUSID,szCONTRACTID,stFields[uiFieldNo].uiNo,stFields[uiFieldNo].szAbbrev,uiError,uiSeverity,GetErrorString((ULONG)uiError),szTmp,szOwnStu,szOwnPsd);
            } 
            else {
                fprintf(pfError2,"%08lu %-16s %03u %-8s %06u %04u %s <%s>        %s        %s\n",ulCurRecordNo,szHUSID,stFields[uiFieldNo].uiNo,stFields[uiFieldNo].szAbbrev,uiError,uiSeverity,GetErrorString((ULONG)uiError),szTmp,szOwnStu,szOwnPsd);
            }
        }
		
		/* if severity <10 then write to the .WARNINGS file */
        if(uiSeverity<WARNINGLEVEL && uiError && uinWarning<ulMaxWarnings)
            if (bContract) {
		    fprintf(pfError3,"%08lu %-16s %-20s %03u %-8s %06u %04u %s <%s>        %s        %s\n",ulCurRecordNo,szHUSID,szCONTRACTID,stFields[uiFieldNo].uiNo,
	    	    stFields[uiFieldNo].szAbbrev,uiError,uiSeverity,GetErrorString((ULONG)uiError),szTmp,szOwnStu,szOwnPsd);	
            }
            else {
                fprintf(pfError3,"%08lu %-16s %03u %-8s %06u %04u %s <%s>        %s        %s\n",ulCurRecordNo,szHUSID,stFields[uiFieldNo].uiNo,
	    	    stFields[uiFieldNo].szAbbrev,uiError,uiSeverity,GetErrorString((ULONG)uiError),szTmp,szOwnStu,szOwnPsd);	
            }

		
		if(uinWarning == ulMaxWarnings && !WarningMessageDone){
				WarningMessageDone =1;
				fprintf(pfError3,"\nNo of Warnings has reached %u\n ",uinWarning);
		}
	}	
		
	/* 2. it is to be output in database format */
	else if (Options.bDBOutput) {
		if (Options.bVerbose) {                     
			fprintf(pfError,"%08lu %-16s %03u %-8s %06u %04u %s <%100s>        %s        %s\n",ulCurRecordNo,szHUSID,stFields[uiFieldNo].uiNo,stFields[uiFieldNo].szAbbrev,uiError,uiSeverity,GetErrorString((ULONG)uiError),szTmp,szOwnStu,szOwnPsd);
		  }
		else if ((uiError!=0) && uiSeverity>uiWarning) {
			fprintf(pfError,"%08lu %-16s %03u %-8s %06u %04u %s <%100s>        %s        %s\n",ulCurRecordNo,szHUSID,stFields[uiFieldNo].uiNo,stFields[uiFieldNo].szAbbrev,uiError,uiSeverity,GetErrorString((ULONG)uiError),szTmp,szOwnStu,szOwnPsd);
			}
	}      

	/* 3. It is not required in raw output */
	else if (!Options.bRawOutput) {
		if (Options.bVerbose) {                     
			fprintf(pfError,"%08lu %-16s %03u %-8s %06u %04u %s <%s>        %s        %s\n",ulCurRecordNo,szHUSID,stFields[uiFieldNo].uiNo,stFields[uiFieldNo].szAbbrev,uiError,uiSeverity,GetErrorString((ULONG)uiError),szTmp,szOwnStu,szOwnPsd);
	    }
		else if ((uiError!=0) && uiSeverity>=uiWarning) {
			if ((Options.uoType == TY_FIX)||(Options.uoType == TY_CSV)){
				/* -uf or -uc */
				iLen = strlen(szTmp);
				strcpy(szDataTrunc,"<");
				strcat(szDataTrunc,szTmp);
				szDataTrunc[42]='\0'; 
				if (iLen<42) {
					strcat(szDataTrunc,">");
				}
				else {
					strcat(szDataTrunc,"...>");
				}	

				if( uiRNo==11 ||uiRNo==12){
					if (Options.uoType == TY_FIX)	{						
            			fprintf(pfError,"%08lu %-16s %-20s %-20s %03u %-8s %06u %04u %-46s %-500s\n",ulCurRecordNo,szHUSID,szOwnStu,szOwnPsd,stFields[uiFieldNo].uiNo,stFields[uiFieldNo].szAbbrev,uiError,uiSeverity,szDataTrunc,RuleText);
					}
					else {
						fprintf(pfError,"%08lu,\"%-s\",\"%-s\",\"%-s\",%03u,%-s,%06u,%04u,\"%-s\",\"%-s\"\n",ulCurRecordNo,szHUSID,szOwnStu,szOwnPsd,stFields[uiFieldNo].uiNo,stFields[uiFieldNo].szAbbrev,uiError,uiSeverity,szDataTrunc,RuleText);
					}
				}
				else
				{
					if (Options.uoType == TY_FIX)	{
                        if (bContract) {
						    fprintf(pfError,"%08lu %-16s %-20s %03u %-8s %06u %04u %-40s %-500s\n",ulCurRecordNo,szHUSID,szCONTRACTID,stFields[uiFieldNo].uiNo,stFields[uiFieldNo].szAbbrev,uiError,uiSeverity,szDataTrunc,RuleText);
                        }
                        else {
                            fprintf(pfError,"%08lu %-16s %03u %-8s %06u %04u %-40s %-500s\n",ulCurRecordNo,szHUSID,stFields[uiFieldNo].uiNo,stFields[uiFieldNo].szAbbrev,uiError,uiSeverity,szDataTrunc,RuleText);
                        }
					}
					else {
                        if (bContract) {
						    fprintf(pfError,"%08lu,\"%-s\",%-s,%03u,%-s,%06u,%04u,\"%-s\",\"%-s\"\n",ulCurRecordNo,szHUSID,szCONTRACTID,stFields[uiFieldNo].uiNo,stFields[uiFieldNo].szAbbrev,uiError,uiSeverity,szDataTrunc,RuleText);
                        }
                        else {
                            fprintf(pfError,"%08lu,\"%-s\",%03u,%-s,%06u,%04u,\"%-s\",\"%-s\"\n",ulCurRecordNo,szHUSID,stFields[uiFieldNo].uiNo,stFields[uiFieldNo].szAbbrev,uiError,uiSeverity,szDataTrunc,RuleText);
                        }
					}
				}
			}
			else
			{				
			    /* old style default case */
            	fprintf(pfError,"%08lu %-16s %03u %-8s %06u %04u %s <%s>        %s        %s\n",ulCurRecordNo,szHUSID,stFields[uiFieldNo].uiNo,stFields[uiFieldNo].szAbbrev,uiError,uiSeverity,GetErrorString((ULONG)uiError),szTmp,szOwnStu,szOwnPsd);
			}
		} 
		if(uinWarning == ulMaxWarnings && !WarningMessageDone){
				WarningMessageDone =1;
		}
	}
	
	else 
	
	/* 4. it IS required in raw output form */
		{
		if (Options.bVerbose) {               
			fprintf(pfError,"%08lu %-16s %02u %03u %-8s %06u %04u %s <%s> %s %s\n",ulCurRecordNo,szHUSID,uiRNo,
			stFields[uiFieldNo].uiNo,stFields[uiFieldNo].szAbbrev,uiError,uiSeverity,GetErrorString((UINT)uiError),szTmp,szOwnStu,szOwnPsd);
		}
		else if ((uiError!=0) && uiSeverity>=uiWarning) {
			fprintf(pfError,"%08lu %-16s %02u %03u %-8s %06u %04u %s <%s> %s %s\n",ulCurRecordNo,szHUSID,uiRNo,
			stFields[uiFieldNo].uiNo,stFields[uiFieldNo].szAbbrev,uiError,uiSeverity,GetErrorString((UINT)uiError),szTmp,szOwnStu,szOwnPsd);
		}			
	}		


	/* if there has been any error or warning (whether piping or not) then ...  */     
	if (uiError) {           				
	     while((pstvErrors + index)->uiErrorNumber != uiError)
	          index++;
		 (pstvErrors + index)->uiErrorTotal++;              /* increment errortotal each time field in record fails */
		(pstvErrors + index)->uiSeverity = uiSeverity;		/* severity copied to error struct  */
		
		/* if severity is above 10 then increment the error count */
		if (uiSeverity>=WARNINGLEVEL) {         
			uinError++;
		    return uiError;
		}
		else
		{
			/* it is a warning */
			if (!PIPING) {
				/* in standalone mode, only increment warning count when over -w<nn> level */		
				if (uiSeverity>=uiWarning)
				uinWarning++;
			}
			else {
				/* in aardvark mode, always increments warning count.*/
				uinWarning++;
			}
		}

	}				
	return 0;
}                       
/* loops through list of rules can ignore returning 1 if can ignore */                      
#ifdef ANSI
BOOL IgnoreRule(UINT uiRuleNo)  
#else
BOOL IgnoreRule(uiRuleNo)  
UINT uiRuleNo;
#endif
{
	UINT uiCount=0;
	
	while (uiCount<uicIgnoreRules){
		if (ulIgnoreRules[uiCount]==uiRuleNo)
			return 1;
		uiCount++;
		}
	
	return 0;	
	
}
/*  returns fieldnumber given an field abrreviation*/
#ifdef ANSI
UINT GetFieldNoFromAbbrev(const PSZ pszAbbrev)
#else
UINT GetFieldNoFromAbbrev(pszAbbrev)
const PSZ pszAbbrev;
#endif
{
	UINT  uiCount=0;

	for (uiCount=0;uiCount<uinFields;uiCount++) {
		if (!strcmp(pszAbbrev,stFields[uiCount].szAbbrev))
			return uiCount;
		}

	return 0;
}
/* converts fuield contents from string to number*/
#ifdef ANSI
ULONG GetFieldNoInteger(UINT uiFieldNo)
#else
ULONG GetFieldNoInteger(uiFieldNo)
UINT uiFieldNo;
#endif
{
	return atol(GetFieldNoString(uiFieldNo));
}
/*  jt added ,added from GetFieldNoInteger to grab sections of data*/       
#ifdef ANSI
ULONG GetFieldNoIntegerMid(UINT uiFieldNo,int iStart,int iWidth)
#else
ULONG GetFieldNoIntegerMid(uiFieldNo,iStart,iWidth)
UINT uiFieldNo;                                
int iStart;
int iWidth;
#endif
{
	return atol(GetFieldNoStringMid(uiFieldNo,iStart,iWidth));
}
/* the basic function that gets a field using previously calculated offset*/
#ifdef ANSI
PSZ GetFieldNoString(UINT uiFieldNo)
#else
PSZ GetFieldNoString(uiFieldNo)
UINT uiFieldNo;
#endif
{
	static SZ szBuffer[1024];

	strncpy(szBuffer,szLineBuffer+stFields[uiFieldNo].uiOffset,stFields[uiFieldNo].uiLength);
	*(szBuffer+stFields[uiFieldNo].uiLength)=0;

	return szBuffer;
}
/* function that gets a sub string from field using previously calculated offset*/
#ifdef ANSI
PSZ GetFieldNoStringMid(UINT uiFieldNo,int iStart,int iWidth)
#else
PSZ GetFieldNoStringMid(uiFieldNo,iStart,iWidth)
UINT uiFieldNo;
int iStart;
int iWidth;
#endif
{
	static SZ szBuffer[1024];

	strncpy(szBuffer,szLineBuffer+stFields[uiFieldNo].uiOffset+iStart,iWidth);
	*(szBuffer+iWidth)=0;

	return szBuffer;
}

/* function that gets a sub string from 2nd field using previously calculated offset*/
#ifdef ANSI
PSZ GetFieldNoStringMid2(UINT uiFieldNo,int iStart,int iWidth)
#else
PSZ GetFieldNoStringMid2(uiFieldNo,iStart,iWidth)
UINT uiFieldNo;
int iStart;
int iWidth;
#endif
{
	static SZ szBuffer2[1024];

	strncpy(szBuffer2,szLineBuffer+stFields[uiFieldNo].uiOffset+iStart,iWidth);
	*(szBuffer2+iWidth)=0;

	return szBuffer2;
}


/* new routine created by MDE 05.12.2002 */
#ifdef ANSI
PSZ GetField(UINT uiFieldNo)
#else
PSZ GetField(uiFieldNo)
UINT uiFieldNo;
#endif

{
    static SZ szGetFieldBuffer[1024];

    if(Options.uiType==TY_FIX)
    {
	/* fixed length data: get data up to expected length of field.*/
    	strncpy(szGetFieldBuffer,szLineBuffer+stFields[uiFieldNo].uiOffset,stFields[uiFieldNo].uiLength);
	*(szGetFieldBuffer+stFields[uiFieldNo].uiLength)=0;
    }
    else
    {
	/* variable length data: get data up to next field marker */
	strncpy(szGetFieldBuffer,szLineBuffer+stFields[uiFieldNo].uiOffset,1024);
    }
    return szGetFieldBuffer;
}

/* additional routine created by DAB 2005-03-02 */
#ifdef ANSI
PSZ GetField2(UINT uiFieldNo)
#else
PSZ GetField2(uiFieldNo)
UINT uiFieldNo;
#endif

{
    static SZ szGetFieldBuffer2[1024];

    if(Options.uiType==TY_FIX)
    {
	/* fixed length data: get data up to expected length of field.*/
    	strncpy(szGetFieldBuffer2,szLineBuffer+stFields[uiFieldNo].uiOffset,stFields[uiFieldNo].uiLength);
	*(szGetFieldBuffer2+stFields[uiFieldNo].uiLength)=0;
    }
    else
    {
	/* variable length data: get data up to next field marker */
	strncpy(szGetFieldBuffer2,szLineBuffer+stFields[uiFieldNo].uiOffset,1024);
    }
    return szGetFieldBuffer2;
}

/* concatenate 2 fields into 1 string MDE 2005-05-06 */
#ifdef ANSI
PSZ CatFields(UINT uiFieldNo1,UINT uiFieldNo2)
#else
PSZ CatFields(uiFieldNo1,uiFieldNo2)
UINT uiFieldNo1;
UINT uiFieldNo2;
#endif
{
	static char szBufferReturn[6];
	szBufferReturn[0]='\0';
	strcat(szBufferReturn,GetField(uiFieldNo1));
	strcat(szBufferReturn,GetField2(uiFieldNo2));
	return szBufferReturn;
}



/* test for valid integer with a min and max value,also tests number 
occupies width of field*/ 
#ifdef ANSI
BOOL IsValidInteger(UINT uiFieldNo,ULONG ulMin,ULONG ulMax)
#else
BOOL IsValidInteger(uiFieldNo,ulMin,ulMax)
UINT uiFieldNo;
ULONG ulMin;
ULONG ulMax;
#endif
{
	ULONG ulValue=0;
	PSZ pszValue=NULL;
/*	static char szTemp[36];*/

    	pszValue=GetField(uiFieldNo);
    	ulValue=atol(pszValue);
    
	/*commented out by MDE: 
	pszValue=GetFieldNoString(uiFieldNo);
	ulValue=GetFieldNoInteger(uiFieldNo);*/
   
    	/*ltoa(ulMax,szTemp,10);*/
                                 
	/*if (strlen(pszValue)!=strlen(szTemp))*/
	  if (strlen(pszValue)!=stFields[uiFieldNo].uiLength)
		return 0;     
	/* if empty jt */	
    if (strlen(pszValue)==0)
		return 0;                                 
                                 
	if (!(ulValue>=ulMin && ulValue<=ulMax))
		  return 0;
                              
	if (!*pszValue)                              
		return 0;
                              
	while (*pszValue)
		{
		if (!(isdigit(*pszValue)))
			return 0;
		pszValue++;
		}

	return 1;
}
/* checks value against valid list*/  
#ifdef ANSI                                    
BOOL _IsValidCode(struct FLD *pFld,const PSZ pszValue)
#else
BOOL _IsValidCode(pFld,pszValue)
struct FLD *pFld;
const PSZ pszValue;
#endif
{          
	UINT uiCount=0;
               
	/* Trim leading ws - NOT      2004-04-01 (MDE)
	while (isspace(*pszValue) && *pszValue)
		pszValue++; */             
	
	while (uiCount<pFld->uinValid) {
		if (!strncmp(pszValue,pFld->ppszValids[uiCount],
			(strlen(pszValue)>strlen(pFld->ppszValids[uiCount]))?
				strlen(pszValue):
				strlen(pFld->ppszValids[uiCount]) ))		
			return 1;
		uiCount++;
		}
          
	return 0;
}
                                    
#ifdef ANSI
BOOL IsValidCode(UINT uiFieldNo)
#else
BOOL IsValidCode(uiFieldNo)
UINT uiFieldNo;
#endif
{
  	PSZ pszValue=NULL;
	
	/* MDE 13/12/02 changed from: 
	 pszValue=GetFieldNoString(uiFieldNo);
	  to: 	 */
	
	pszValue=GetField(uiFieldNo);
	
	return _IsValidCode(stFields+uiFieldNo,pszValue);
}

#ifdef ANSI
BOOL _IsValidnDigitSocSicCode(struct FLD *pFld,const PSZ pszValue,int iN)
#else
BOOL _IsValidnDigitSocSicCode(pFld,pszValue,iN)
struct FLD *pFld;
const PSZ pszValue;
int iN;
#endif
{
	UINT uiCount=0;
	               
	/* Trim leading ws */	             
	while (isspace(*pszValue) && *pszValue)
		pszValue++;
  
	uiCount=iN;  	
  	while (uiCount<strlen(pszValue))
	{
		if (!isspace(pszValue[uiCount]))
  			return 0;
  		uiCount++;
  	}
	
	uiCount=0;
	while (uiCount<pFld->uinValid) {
		if ( !strncmp( pszValue,pFld->ppszValids[uiCount],iN))
			return 1;
		uiCount++;
		}
  
	return 0;
}
/* not used I dont think*/
#ifdef ANSI
BOOL IsValidnDigitSocSicCode(UINT uiFieldNo,int iN)
#else
BOOL IsValidnDigitSocSicCode(uiFieldNo,iN)
UINT uiFieldNo;
int iN;
#endif
{                  
  
  PSZ pszValue=NULL;

	pszValue=GetFieldNoString(uiFieldNo);
	
	return _IsValidnDigitSocSicCode(stFields+uiFieldNo,pszValue,iN);
}


#ifdef ANSI                               
BOOL IsValidCasocCode(UINT uiFieldNo)                               
#else
BOOL IsValidCasocCode(uiFieldNo)                               
UINT uiFieldNo;
#endif
{
                    
	PSZ pszValue=NULL;                    
	                                             
	pszValue=GetFieldNoString(uiFieldNo);	                                             

	if (_IsFormat(pszValue,"nnnnCC"))
		return 1;   
		
	return 0;		
}


/* wrapper for isvalidcode function*/
#ifdef ANSI
BOOL IsValidCodeForField(UINT uiFieldNo,const PSZ pszValue)
#else
BOOL IsValidCodeForField(uiFieldNo,pszValue)
UINT uiFieldNo;
const PSZ pszValue;
#endif
{
	return _IsValidCode(stFields+uiFieldNo,pszValue);	
}
/* test for alphanum with a min and max length */
#ifdef ANSI
BOOL IsValidAlphanum(UINT uiFieldNo,UINT uiMinLength,UINT uiMaxLength)
#else
BOOL IsValidAlphanum(uiFieldNo,uiMinLength,uiMaxLength)
UINT uiFieldNo;
UINT uiMinLength;
UINT uiMaxLength;
#endif
{
	PSZ pszValue=NULL;
	pszValue=GetField(uiFieldNo);
	
	if (!(strlen(pszValue)>=uiMinLength && strlen(pszValue)<=uiMaxLength))
		return 0;
	while (*pszValue)
		{
		if (!(*(unsigned char *)pszValue>=32 && *(unsigned char *)pszValue<=127))
			return 0;
		pszValue++;
		}
	return 1;
}

/* tests for valid date, can be in three formats*/ 
#ifdef ANSI
BOOL _IsValidDate(UINT uiFieldNo,struct HesaDate *phd)
#else
BOOL _IsValidDate(uiFieldNo,phd)     
UINT uiFieldNo;
struct HesaDate *phd;
#endif
{
	/* date can be in format DD/MM/YYYY or DD-MM-YYYY or YYYYMMDD
	however because of the example in the coding manual (1/1/YYYY)
	valid formats are DD/MM/YYYY, D/M/YYYY, D/MM/YYYY, DD/M/YYYY,
	DD-MM-YYYY, D-M-YYYY, D-MM-YYYY, DD-M-YYYY and YYYYMMDD */

	UINT uiDay=0;
	UINT uiMonth=0;
	UINT uiYear=0;
	UINT uiMonthOffset=0;
	UINT uiYearOffset=0;
	UINT uiMaxDaysInMonth=0;
	SZ szDay[3];
	SZ szMonth[3];
	SZ szYear[5];
	PSZ pszValue=NULL;
	PSZ pszValueStart=NULL;
	
	/* MDE 07/01/2003 - was: pszValue=GetFieldNoString(uiFieldNo); 
	Also check that it is one of the accepted formats */
	
	pszValue=GetField(uiFieldNo);
	if (!(
	_IsFormat(pszValue,"nn?/nn?/nnnn") ||
	_IsFormat(pszValue,"n?/n?/nnnn") ||
	_IsFormat(pszValue,"n?/nn?/nnnn") ||
	_IsFormat(pszValue,"nn?/n?/nnnn") ||
	_IsFormat(pszValue,"nn?-nn?-nnnn") ||
	_IsFormat(pszValue,"n?-n?-nnnn") ||
	_IsFormat(pszValue,"n?-nn?-nnnn") ||
	_IsFormat(pszValue,"nn?-n?-nnnn") ||
	_IsFormat(pszValue,"nnnnnnnn") )) return 0;
	
	/* MDE 07/01/2003 - end of amendment */
	
	pszValueStart=pszValue;
                               
                               
	if (phd) {
		phd->uiYear=0;
		phd->uiMonth=0;
		phd->uiDay=0;
		}
                               
	/* to start with lets get the 3 parts of the date into some ints */
	if (strchr(pszValue,'/')!=NULL || strchr(pszValue,'-')!=NULL)
		{
		while (*pszValue)
			{
			if (*pszValue=='/' || *pszValue=='-')
				{
				*pszValue=0;
				if (uiMonthOffset)
					uiYearOffset=(UINT)(pszValue+1-pszValueStart);
				else
					uiMonthOffset=(UINT)(pszValue+1-pszValueStart);
				}
			pszValue++;
		}
		/* MDE same change again */
		pszValue=GetField(uiFieldNo);
		uiDay=atoi(pszValue);
		uiMonth=atoi(pszValue+uiMonthOffset);
		uiYear=atoi(pszValue+=uiYearOffset);
		}
	else
		{
		strncpy(szYear,pszValue,4);
		szYear[4]=0;
		strncpy(szMonth,(pszValue+4),2);
		szMonth[2]=0;
		strncpy(szDay,(pszValue+6),2);
		szDay[2]=0;
		uiYear=atoi(szYear);
		uiMonth=atoi(szMonth);
		uiDay=atoi(szDay);
		}

	if (!(uiYear>=1900 && uiYear<=9999))
		{
		return 0;
		}
	if (!((uiMonth>=1 && uiMonth<=12)||(uiMonth ==99 && uiDay==99 && uiYear==9999)))
		{
		return 0;
		}
	switch (uiMonth)
		{
		case 1:
		case 3:
		case 5:
		case 7:
		case 8:
		case 10:
		case 12: uiMaxDaysInMonth=31;
			break;
		case 4:
		case 6:
		case 9:
		case 11: uiMaxDaysInMonth=30;
			break;
		case 2: 
			uiMaxDaysInMonth=28;                                        
			/* changed to line below on 13 MAy 99 - jt*/
		 	if (IsItALeapYear(uiYear))
				uiMaxDaysInMonth=29;
			break;				
		}
	if (!((uiDay>=1 && uiDay<=uiMaxDaysInMonth)||(uiDay ==99 && uiMonth ==99 && uiYear ==9999)))
		{
		return 0;
		}


	if (phd) {
		phd->uiYear=uiYear;
		phd->uiMonth=uiMonth;
		phd->uiDay=uiDay;
		}

	return 1;
}

/* changes data into julien form ie one number*/ 
unsigned long ulJDate(int date,int month,int year)
{
	unsigned long ulR=0;
	int wcYear,wcMonth;

	for (wcYear=1900;wcYear<year;wcYear++) {
		if (!(wcYear%4))
			ulR+=366;
		else
			ulR+=365;
		}

	for (wcMonth=0;wcMonth<month-1;wcMonth++) {
		if (wcMonth==1 && IsItALeapYear(year))    
			ulR+=29;
		else
			ulR+=rgMonths[wcMonth].days;
		}

	ulR+=date-1;

	return(ulR);

}
                    
/* calculates date difference by second parameter*/
#ifdef ANSI                    
SLONG _DateDiff(UINT uiInterval,const PSZ psz1,const PSZ psz2)                    
#else 
SLONG _DateDiff(uiInterval,psz1,psz2)                    
UINT uiInterval;
const PSZ psz1;
const PSZ psz2;

#endif
{
	struct HesaDate hd1;
	struct HesaDate hd2;
	static SZ sz1[32];
	static SZ sz2[32];
	
	strcpy(sz1,psz1);
	strcpy(sz2,psz2);
	
  	*(sz1+2)=0;
  	*(sz2+2)=0;
  
  	*(sz1+5)=0;
  	*(sz2+5)=0;
          
	hd1.uiDay=atoi(sz1);          
	hd2.uiDay=atoi(sz2);          
	                               
	hd1.uiMonth=atoi(sz1+3);          	                               
	hd2.uiMonth=atoi(sz2+3);          	                               
	
	hd1.uiYear=atoi(sz1+6);          	                               
	hd2.uiYear=atoi(sz2+6);          	                               	
          
	
  switch(uiInterval) {
  case YEAR:
  	return hd1.uiYear-hd2.uiYear;
  	break;

  case MONTH:
  	return hd1.uiMonth-hd2.uiMonth;
  	break;  
  	
  case DAY:    
  	hd1.ulJulian=ulJDate(hd1.uiDay,hd1.uiMonth,hd1.uiYear);
  	hd2.ulJulian=ulJDate(hd2.uiDay,hd2.uiMonth,hd2.uiYear);
  	
  	return hd1.ulJulian-hd2.ulJulian;
  	break;
    
 	default:
 		return ERRDATE;
    
  	}
}


#ifdef ANSI                    
SLONG DateDiff(UINT uiInterval,UINT uiFieldNo1,UINT uiFieldNo2)                    
#else 
SLONG DateDiff(uiInterval,uiFieldNo1,uiFieldNo2)                    
UINT uiInterval;
UINT uiFieldNo1;
UINT uiFieldNo2;
#endif
{
	struct HesaDate hd1;
	struct HesaDate hd2;
		
	if (!_IsValidDate(uiFieldNo1,&hd1))
		return ERRDATE;
	
	if (!_IsValidDate(uiFieldNo2,&hd2))
		return ERRDATE;

	
  switch(uiInterval) {
  case YEAR:
  	return hd1.uiYear-hd2.uiYear;
  	break;

  case MONTH:
  	return hd1.uiMonth-hd2.uiMonth;
  	break;  
  	
  case DAY:    
  	hd1.ulJulian=ulJDate(hd1.uiDay,hd1.uiMonth,hd1.uiYear);
  	hd2.ulJulian=ulJDate(hd2.uiDay,hd2.uiMonth,hd2.uiYear);
  	
  	return hd1.ulJulian-hd2.ulJulian;
  	break;
    
 	default:
 		return ERRDATE;
    
  	}
}

           
/* returns 2nd parameter part of date*/
#ifdef ANSI                    
ULONG DateSplit(UINT uiInterval,UINT uiFieldNo1)                    
#else 
ULONG DateSplit(uiInterval,uiFieldNo1)                    
UINT uiInterval;
UINT uiFieldNo1;

#endif
{
	struct HesaDate hd1;
	
	if (!_IsValidDate(uiFieldNo1,&hd1))
		return ERRDATE;
	
  switch(uiInterval) {
  case YEAR:
  	return hd1.uiYear;
  	break;

  case MONTH:
  	return hd1.uiMonth;
  	break;  
  	
  case DAY:    
  	return hd1.uiDay;
  	break;
    
 	default:
 		return ERRDATE;
    
  	}
}             
/* prints out valid date in dd/mm/yy format */
#ifdef ANSI
PSZ GetFieldNoDate(UINT uiFieldNo)
#else
PSZ GetFieldNoDate(uiFieldNo)     
UINT uiFieldNo;
#endif        
{
	static char szBf[32];

	struct HesaDate hd;
	
	*szBf=0;
	
	if (!_IsValidDate(uiFieldNo,&hd))
		return szBf;
	
	sprintf(szBf,"%02i/%02i/%04i",hd.uiDay,hd.uiMonth,hd.uiYear);	
	
	return szBf;
}
                 

             
             
#ifdef ANSI
BOOL IsValidDate(UINT uiFieldNo)
#else
BOOL IsValidDate(uiFieldNo)
UINT uiFieldNo;
#endif
{
return _IsValidDate(uiFieldNo,NULL);	
}
/* tests date but for short format*/
#ifdef ANSI
BOOL IsValidShortDate(UINT uiFieldNo)
#else
BOOL IsValidShortDate(uiFieldNo)
UINT uiFieldNo;
#endif
{
	/* 
	  date can be in format MM/YYYY or MM-YYYY or YYYYMM
	*/

	UINT uiMonth=0;
	UINT uiYear=0;
	UINT uiYearOffset=0;
	SZ szMonth[3];
	SZ szYear[5];
	PSZ pszValue=NULL;
	PSZ pszValueStart=NULL;
	pszValue=GetFieldNoString(uiFieldNo);
	pszValueStart=pszValue;

	/* to start with lets get the 3 parts of the date into some ints */
	if (strchr(pszValue,'/')!=NULL || strchr(pszValue,'-')!=NULL)
		{
		while (*pszValue)
			{
			if (*pszValue=='/' || *pszValue=='-')
				{
				*pszValue=0;
				uiYearOffset=(UINT)(pszValue+1-pszValueStart);
				}
			pszValue++;
			}
	
		pszValue=GetFieldNoString(uiFieldNo);
		uiMonth=atoi(pszValue);
		uiYear=atoi(pszValue+=uiYearOffset);
		}
	else
		{
		strncpy(szYear,pszValue,4);
		szYear[4]=0;
		strncpy(szMonth,(pszValue+4),2);
		szMonth[2]=0;
		uiYear=atoi(szYear);
		uiMonth=atoi(szMonth);
		}

	if (!(uiYear>=1900 && uiYear<=9999))
		{
		return 0;
		}

	if (!(uiMonth>=1 && uiMonth<=12))
		{
		return 0;
		}

	return 1;
}

/* DAB 21 Jan 2004, tests for valid date in format YYYYMMDD */ 
#ifdef ANSI
BOOL IsValid8DigitDate(UINT uiFieldNo)
#else
BOOL IsValid8DigitDate(uiFieldNo)
UINT uiFieldNo;
#endif
{
	PSZ pszValue=NULL;
	
	pszValue=GetField(uiFieldNo);	
	if (!(_IsFormat(pszValue,"nnnnnnnn")))
	{ 
		return 0;
	}
	else
	{
		return _IsValidDate(uiFieldNo,NULL);		
	}
}

/* returns value of one of the global switches*/
#ifdef ANSI
BOOL  GetGlobalSwitch(UINT uiSwitchNo)
#else
BOOL  GetGlobalSwitch(uiSwitchNo)
UINT uiSwitchNo;
#endif
{
	return Options.bGlobal[uiSwitchNo];
}

/* returns whether it is a reduced return y testing 3rd character of data line*/
#ifdef ANSI
BOOL IsReducedReturn(UINT uiReduced)
#else                               
BOOL IsReducedReturn(uiReduced)
UINT uiReduced;
#endif
{          
	if (uiReduced==Options.uiReduced)
		return 1;
		
	if (((UINT)atoi(GetFieldNoString(0)+2))==uiReduced)	
		return 1;
		
	return 0;		
		
}
/* function compares field content to passed string with case choice*/
#ifdef ANSI
BOOL CompFieldNoString(UINT uiFieldNo,const PSZ pszCompare,BOOL fCase)
#else
BOOL CompFieldNoString(uiFieldNo,pszCompare,fCase)
UINT uiFieldNo;
const PSZ pszCompare;
BOOL fCase;
#endif
{
	PSZ pszValue=NULL;
	/* pszValue=GetFieldNoString(uiFieldNo);  replaced  MDE 2005-03-01 */
   pszValue=GetField(uiFieldNo);
	             
	/* Trim Leading whitespace  **  commented out MDE 2005-03-01 **
	while (isspace(*pszValue) && *pszValue)
		pszValue++; 
	*/
	

	if (fCase==1)
		{
		if (strcmp(pszValue,pszCompare)==0)
			{
			return 1;
			}
		}
	if (fCase==0)
		{
		if (strcmpi(pszValue,pszCompare)==0)
			{
			return 1;
			}
		}
	return 0;
}                            
                            
#ifdef ANSI
BOOL IsReallyEmpty(UINT uiFieldNo)                            
#else
BOOL IsReallyEmpty(uiFieldNo)
UINT uiFieldNo;                            
#endif
{
	    	
	if (CompFieldNoString(uiFieldNo,"",0))
		return 1;
		
	return 0;
}
/* compares field contents to empty string*/
#ifdef ANSI
BOOL IsEmpty(UINT uiFieldNo)
#else
BOOL IsEmpty(uiFieldNo)
UINT uiFieldNo;
#endif
{ 

	if (CompFieldNoString(uiFieldNo,"",0))
		return 1;

	return 0;
}
/* tests field for valid proportion mina and max must be 5 in length eg 100.0*/

#ifdef ANSI
BOOL IsValidProportion(UINT uiFieldNo,UINT uiMin,UINT uiMax)
#else
BOOL IsValidProportion(uiFieldNo,uiMin,uiMax)
UINT uiFieldNo;
UINT uiMin;
UINT uiMax;
#endif
{
	UINT uiValue=0;
	PSZ pszValue=NULL;                   
	
	/* amended by MDE 7/1/03 - was : pszValue=GetFieldNoString(uiFieldNo);   */
	pszValue=GetField(uiFieldNo);
	
	if (strlen(pszValue)!=5)	                    
		return 0;
		

	if (!isdigit(*(pszValue+0)))		
		return 0;

	if (!isdigit(*(pszValue+1)))		
		return 0;

	if (!isdigit(*(pszValue+2)))		
		return 0;
	
	if (*(pszValue+3)!='.')		
		return 0;

	if (!isdigit(*(pszValue+4)))		
		return 0;
			
	*(pszValue+3)=0;
	
	uiValue=atoi(pszValue)*10;
	uiValue+=atoi(pszValue+4);
	
	if (uiValue<uiMin)
		return 0;
	                    
	if (uiValue>uiMax)
		return 0;
	
	return 1;	
	
}                             
	/* checks postcode against list of valid postcodes*/
#ifdef ANSI 
BOOL PostCodeOK_1(const PSZ pszCode)
#else
BOOL PostCodeOK_1(pszCode)
const PSZ pszCode;
#endif
{
	SZ szPC[16];
	SZ szWhiteSpaceAtEnd[5]={"wwww"};
	SZ szFormat[7]={"wnCCww"};
	PSZ lpsScan=NULL;
	int nIndex =1;
	int OutwardChar=0;
	int nFieldLen= strlen(pszCode);
	if (strlen(pszCode)>8)
		return 0;
	
	strcpy(szPC,pszCode);

	lpsScan=szPC;
	
	while (*lpsScan && isalnum(*lpsScan)) {
		lpsScan++;
		}
    

	while (*(lpsScan +nIndex)){
		if(isalnum(*(lpsScan+nIndex)))
			OutwardChar++;
		nIndex++;
		}
	/* jt changed coz was passing Cn as inward code */    	
	if(nFieldLen- (lpsScan-szPC)){
	   szFormat[nFieldLen- (lpsScan-szPC)] = '\0';                 
	   if(!_IsFormat(lpsScan,szFormat)||OutwardChar != 3 )
	     return 0;
  	}
	   

	/* make fresh end of string to get outward part of postcode*/
	*lpsScan=0;
	
		
	return IsValidPostCode(szPC);	
	
} 
 
#ifdef ANSI
BOOL PostCodeOK(UINT uiFieldNo)
#else
BOOL PostCodeOK(uiFieldNo)
UINT uiFieldNo;
#endif
{                   
	PSZ pszValue=NULL;
	
	pszValue=GetFieldNoString(uiFieldNo);	                                             
	return PostCodeOK_1(pszValue);
			
}
/* not called */                               
#ifdef ANSI                               
BOOL PostCodeLooksOK(UINT uiFieldNo)                               
#else
BOOL PostCodeLooksOK(uiFieldNo)                               
UINT uiFieldNo;
#endif
{
                    
	PSZ pszValue=NULL;                    
	PSZ pszEnd;
	                                             
	pszValue=GetFieldNoString(uiFieldNo);	                                             
	pszEnd=pszValue+strlen(pszValue)-1;
	
	while (pszEnd>pszValue && isspace(*pszEnd))
		pszEnd--;

	pszEnd++;		
	
	*pszEnd=0;


	if (_IsFormat(pszValue,"CnwnCC"))
		return 1;

	if (_IsFormat(pszValue,"CnCwnCC"))
		return 1;

	if (_IsFormat(pszValue,"CnnwnCC"))
		return 1;
		
	if (_IsFormat(pszValue,"CCnwnCC"))
		return 1;              
		
	if (_IsFormat(pszValue,"CCnnwnCC"))
		return 1;               
		
	if (_IsFormat(pszValue,"CCnCwnCC"))
		return 1;


	if (_IsFormat(pszValue,"Cn"))
		return 1;

	if (_IsFormat(pszValue,"CnC"))
		return 1;

		
	if (_IsFormat(pszValue,"Cnn"))
		return 1;
		
	if (_IsFormat(pszValue,"CCn"))
		return 1;              
		
	if (_IsFormat(pszValue,"CCnn"))
		return 1;               
		
	if (_IsFormat(pszValue,"CCnC"))
		return 1;

		
	return 0;		
}
/* not used */
#ifdef ANSI
BOOL ChecksumOK(UINT uiFieldNo)
#else
BOOL ChecksumOK(uiFieldNo)
UINT uiFieldNo;
#endif
{
	PSZ pszValue=NULL;
	PSZ pszScan=NULL;
/*	UINT uiDigit=0;*/
	UINT uiAccuProduct=0;
	/*UINT uiCount=1;*/
	UINT uiOrigCheckDigit=0;
	UINT uiMyCheckDigit=0;
	int nlenData;
	int nTimes[12]= {1,3,7,9,1,3,7,9,1,3,7,9};
	int nIndex;
	pszValue=pszScan=GetFieldNoString(uiFieldNo);
	nlenData = strlen(pszValue);

	nIndex=0;
	while (*pszScan)
	{
		if (!(isdigit(*pszScan)))
		{	
			/* ~  (DAB - 12/02/2004) Check for X (ascii 88) in first 2 chars   */
			if(!(*pszScan==88 && nIndex<2))
			{
				return 0;
			}
		}

		pszScan++;
		nIndex++;
	}         
						
	if (!(nlenData==(int) stFields[uiFieldNo].uiLength))
		return 0;
		
	for(nIndex=0;nIndex <nlenData-1;nIndex++)
	{
		/* ~ (DAB 12/02/2004) Not include chars in product    */
		if(isdigit(*(pszValue+nIndex)))
		{
			uiAccuProduct+=((char) *(pszValue+nIndex)-48) * nTimes[nIndex];
		}	
	}
	
	uiOrigCheckDigit=((char) *(pszValue+nlenData-1)-48);
	uiMyCheckDigit=uiAccuProduct%10;

		if (uiMyCheckDigit==0)
			{
			uiMyCheckDigit=0;
			}
		else			         
			uiMyCheckDigit=10-uiMyCheckDigit;
			
		if (!(uiOrigCheckDigit==uiMyCheckDigit))
			{
			return 0;
			}
			
	return 1;
}

#ifdef ANSI
BOOL IncorrectChecksumOK(UINT uiFieldNo)
#else
BOOL IncorrectChecksumOK(uiFieldNo)
UINT uiFieldNo;
#endif
{
    /*	New function: same as ChecksumOK but with different weightings*/
	PSZ pszValue=NULL;
	PSZ pszScan=NULL;
/*	UINT uiDigit=0;*/
	UINT uiAccuProduct=0;
	/*UINT uiCount=1;*/
	UINT uiOrigCheckDigit=0;
	UINT uiMyCheckDigit=0;
	int nlenData;
	int nTimes[12]= {0,3,7,9,0,3,7,9,0,3,7,9};
	int nIndex;
	pszValue=pszScan=GetFieldNoString(uiFieldNo);
	nlenData = strlen(pszValue);

	nIndex=0;
	while (*pszScan)
	{
		if (!(isdigit(*pszScan)))
		{	
			/* ~  (DAB - 12/02/2004) Check for X (ascii 88) in first 2 chars   */
			if(!(*pszScan==88 && nIndex<2))
			{
				return 0;
			}
		}

		pszScan++;
		nIndex++;
	}         
						
	if (!(nlenData==(int) stFields[uiFieldNo].uiLength))
		return 0;
		
	for(nIndex=0;nIndex <nlenData-1;nIndex++)
	{
		/* ~ (DAB 12/02/2004) Not include chars in product    */
		if(isdigit(*(pszValue+nIndex)))
		{
			uiAccuProduct+=((char) *(pszValue+nIndex)-48) * nTimes[nIndex];
		}	
	}
	
	uiOrigCheckDigit=((char) *(pszValue+nlenData-1)-48);
	uiMyCheckDigit=uiAccuProduct%10;

		if (uiMyCheckDigit==0)
			{
			uiMyCheckDigit=0;
			}
		else			         
			uiMyCheckDigit=10-uiMyCheckDigit;
			
		if (!(uiOrigCheckDigit==uiMyCheckDigit))
			{
			return 0;
			}
			
	return 1;
}


 /* checks format of string*/  
#ifdef ANSI
BOOL _IsFormat(const PSZ pszValue,const PSZ pszFormat)
#else
BOOL _IsFormat(pszValue,pszFormat)
const PSZ pszValue;
const PSZ pszFormat;
#endif
{

/*------------------------------------------------------**
** 	format must only contain 'C', 'A' or 'n' characters **
**     C is for character                               **
**     A is for alphanumeric                            **
**     n is for digit                                   **
**     ? means count next char as a literal 			**
**------------------------------------------------------*/
/* count ? in format string */
	int nIndex=0;
	int nQCount=0;
    while(*(pszFormat+nIndex))
    	if(*(pszFormat+nIndex++)=='?') nQCount++; 

	if ( strlen(pszFormat)!=strlen(pszValue)+nQCount )
		return 0;
	
	while (*pszValue)
		{
		switch (*pszFormat)
			{
			case 'C':
				if (!isalpha(*pszValue))
					return 0;
				break;
			case 'A':
				if (!isalnum(*pszValue))
					return 0;
				break;
			case 'n':
				if (!isdigit(*pszValue))
					return 0;
				break;

			case 'w':
				if (!isspace(*pszValue))
					return 0;
				break;
				
			case '\\':
				pszFormat++;
				if (*pszValue!=*pszFormat)
					return 0;
				
				break;				
			case '?':
				pszFormat++;
				if (*pszValue!=*pszFormat)
					return 0;
				
				break;					
				
			/* 	format must only contain 'C', 'A' or 'n' characters */
			default:
				return 0;
			}
		pszValue++;
		pszFormat++;
		}
	return 1;
}

#ifdef ANSI
BOOL IsFormat(UINT uiFieldNo,const PSZ pszFormat)
#else
BOOL IsFormat(uiFieldNo,pszFormat)
UINT uiFieldNo;
const PSZ pszFormat;
#endif
{
	PSZ pszValue=NULL;
	
	/* amended MDE 17/12/2002 - was GetFieldNoString */		
	pszValue=GetField(uiFieldNo);

  return _IsFormat(pszValue,pszFormat);
  
}



/*IsFirstBitOfHusidOK Added 17/10/95 Adrian Crossley
  Instids can be obselete or current */
#ifdef ANSI
BOOL IsFirstBitOfHusidOK(UINT uiFieldNo)
#else
BOOL IsFirstBitOfHusidOK(uiFieldNo)
UINT uiFieldNo;
#endif
{
	PSZ pszValue=NULL;
	PSZ pszInstIDChars=NULL;
	
			
	pszValue=GetFieldNoString(uiFieldNo);
	
	if (strncmp(pszValue,"0000",4)!=0)
	{	
		pszInstIDChars=pszValue+2;
		*(pszInstIDChars+4)=0;

		switch (*pszInstIDChars)
		{
			case '1':  
				*pszInstIDChars='0';  /*instid beginning with 0*/
				if(IsValidCodeForField(GetFieldNoFromAbbrev("LASTINST"),pszInstIDChars))
        			return 1;
				return IsValidCodeForField(GetFieldNoFromAbbrev("INSTID"),pszInstIDChars);
				break;
		  	case '3':
				*pszInstIDChars='2';  /*instid beginning with 2*/
				if(IsValidCodeForField(GetFieldNoFromAbbrev("LASTINST"),pszInstIDChars))
        			return 1;
				return IsValidCodeForField(GetFieldNoFromAbbrev("INSTID"),pszInstIDChars);
				break;
		    default:  /*instid not beginning with 0 or 2 are not valid*/
				return 0;
		}
	}
	else
	{
		return 1;
	}
}
			/*  IsOldInstInHusid added 20 August 97 to allow field 4 of staff record to access */
#ifdef ANSI                                                
BOOL IsOldInstInHusid(UINT uiCurFieldNo)
#else                                    
BOOL IsOldInstInHusid(uiCurFieldNo)
UINT uiCurFieldNo;
#endif
{   
	PSZ pszValue=NULL;
	pszValue=GetFieldNoString(uiCurFieldNo);
	pszValue = pszValue +2;
	*(pszValue +4) = '\0';
	pszValue[0]--;
	return CheckTable(pszValue,OLDINSTLIST);                                                     
}  


#ifdef ANSI
double GetFieldNoDouble(UINT uiFieldNo)
#else
double GetFieldNoDouble(uiFieldNo)
UINT uiFieldNo;
#endif
{
	return atof(GetFieldNoString(uiFieldNo));
}

#ifdef ANSI
BOOL IsValidUnPaddedInteger(UINT uiFieldNo,ULONG ulMin,ULONG ulMax)
#else
BOOL IsValidUnPaddedInteger(uiFieldNo,ulMin,ulMax)
UINT uiFieldNo;
ULONG ulMin;
ULONG ulMax;
#endif
{
	ULONG ulValue=0;
	PSZ pszValue=NULL;
	static char szTemp[36];
		
	pszValue=GetFieldNoString(uiFieldNo);
	ulValue=GetFieldNoInteger(uiFieldNo);
                                     
	ltoa(ulMax,szTemp,10);
                                 
	if (strlen(pszValue)>strlen(szTemp))
		return 0;
                                 
	if (!(ulValue>=ulMin && ulValue<=ulMax))
		  return 0;
                              
	if (!*pszValue)                              
		return 0;
                              
	while (*pszValue)
		{
		if (!(isdigit(*pszValue)))
			return 0;
		pszValue++;
		}

	return 1;
}
  
/* print out field contents dependent on the file type */
#ifdef ANSI
PSZ GetOutFieldNoString(UINT uiFieldNo)
#else
PSZ GetOutFieldNoString(uiFieldNo)
UINT uiFieldNo;
#endif
{
	PSZ lpsContents=NULL;
	SZ  szFormat[16];
	static SZ	szReturn[1024];


	switch (stFields[uiFieldNo].uiType) {
	case 0:
	case 1:
		lpsContents=GetFieldNoString(uiFieldNo);
		sprintf(szFormat,"%%-%us",stFields[uiFieldNo].uiLength);
		break;
	case 3:
		lpsContents=GetFieldNoDate(uiFieldNo);
		sprintf(szFormat,"%%-%us",stFields[uiFieldNo].uiLength);

		break;

		}

	if (lpsContents)
		sprintf(szReturn,szFormat,lpsContents);

	return szReturn;

}
/* checks if space or alpha and certain length*/
#ifdef ANSI
BOOL IsValidName(UINT uiFieldNo,UINT uiMinLength,UINT uiMaxLength)
#else
BOOL IsValidName(uiFieldNo,uiMinLength,uiMaxLength)
UINT uiFieldNo;
UINT uiMinLength;
UINT uiMaxLength;
#endif
{
	PSZ pszValue=NULL;

	pszValue=GetFieldNoString(uiFieldNo);

	if (!(strlen(pszValue)>=uiMinLength && strlen(pszValue)<=uiMaxLength))
		return 0;
	while (*pszValue){
		if (isalpha((int)pszValue)||isspace((int)pszValue))
			return 0;          
		pszValue++;
		}
	return 1;
}
/* goes through string checking for certain type*/
#ifdef ANSI
BOOL IsCorrectType(UINT uiFieldNo,UINT uiStart,UINT uiMaxLength,PSZ pszStrType)
#else                                                             
BOOL IsCorrectType(uiFieldNo,uiStart,uiMaxLength,pszStrType)
UINT uiFieldNo;                               
UINT uiStart;
UINT uiMaxLength;                                             
PSZ pszStrType;
#endif
{	/* note returning 0 means that an illegal character has been found*/
	/* returning one means the characters in the tested string are fine*/
	PSZ pszValue=NULL;     
	int NotFound =0;
	UINT uiCurValid=0;
	struct FLD *pFld = stFields + uiFieldNo;
	pszValue=GetFieldNoString(uiFieldNo);
	if(strlen(pszValue)> 40)
		return 0;  
    pszValue+=uiStart;
	if(!strcmp(pszStrType,"Alpha")){   
   	    while(*pszValue && uiMaxLength>0){	
	    	if(!isalpha(*pszValue)) 
	    		NotFound=1;
	    	pszValue++;	
			uiMaxLength--;                
			if(NotFound) 
				return 0;
			}
			 return 1;  
			}
	
	else if(!strcmp(pszStrType,"Alpha9")){
   		while(*pszValue && uiMaxLength>0){	
	    	if(!(isalpha(*pszValue)||*pszValue=='9')) 
	    		NotFound=1;
	    	pszValue++;	
			uiMaxLength--;                
			if(NotFound) 
				return 0;
			}
			 return 1;  
			}
	else if(!strcmp(pszStrType,"AlphaNum")){       		
   		while(*pszValue && uiMaxLength>0){	
	    	if(!(isalnum(*pszValue))) 
	    		NotFound=1;
	    	pszValue++;	
			uiMaxLength--;                
			if(NotFound) 
				return 0;
			}
			 return 1;  
			}
    		/* go through valid characters for name fields*/
    else if(!strcmp(pszStrType,"AlphaNumSp")){       		
   		while(*pszValue && uiMaxLength>0){	
	    	if(!(isalnum(*pszValue)||*pszValue==' ')) 
	    		NotFound=1;
	    	pszValue++;	
			uiMaxLength--;                
			if(NotFound) 
				return 0;
			}
			 return 1;  
			}		
	else if(!strcmp(pszStrType,"List")){ 
	    while(*pszValue && uiMaxLength>0){	
	    	uiCurValid=0;
	    	NotFound = 1;
	    	if(!isalpha(*pszValue)){
	    		while(uiCurValid < pFld->uinValid){               
	    			if(strchr(pFld->ppszValids[uiCurValid],*pszValue)) 
	    				NotFound=0;
	    			uiCurValid++;	
	    			}
	    		}
	    		else
	    			NotFound=0;
	    		pszValue++;	
				uiMaxLength--;                
				if(NotFound) 
					return 0;
			}
			 return 1;  
			}
	else if(!strcmp(pszStrType,"List9")){ 
	    while(*pszValue && uiMaxLength>0){	
	    	uiCurValid=0;
	    	NotFound = 1;
	    	if(!isalpha(*pszValue)){
	    		while(uiCurValid < pFld->uinValid){
	    			if((strchr(pFld->ppszValids[uiCurValid],*pszValue))||*pszValue=='9') 
	    				NotFound=0;
	    			uiCurValid++;	
	    			}
	    		}
	    		else
	    			NotFound=0;
	    		pszValue++;	
				uiMaxLength--;                
				if(NotFound) 
					return 0;
			}
			 return 1;  
			}			                
	else{ 		        
	   while(*pszValue && uiMaxLength>0){	
	    	uiCurValid=0;
	    	NotFound = 1;
	    	if(!isalpha(*pszValue)){
	    		while(uiCurValid < pFld->uinValid){
	    			if((strchr(pFld->ppszValids[uiCurValid],*pszValue))||*pszValue=='9') 
	    				NotFound=0;
	    			uiCurValid++;	
	    			}
	    		}
	    		else
	    			NotFound=0;
	    		pszValue++;	
				uiMaxLength--;                
				if(NotFound) 
					return 0;
			 }
			 return 1;  
			 }
}          


#ifdef ANSI
int GetSub()
#else
int GetSub()
#endif
{      
	/*	Code altered to use integers as double+double+double!=double*3
		because can't represent float values perfectly in binary*/

	int i=0;
	int iGSFieldNo = 101;
	while((iGSFieldNo < 147) && !IsEmpty(iGSFieldNo)){
		i +=  atoi(StripChar(GetFieldNoString(iGSFieldNo),'.'));
		iGSFieldNo +=3;
		}
	
	
	return i;
    /*
	double p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16;
    p1 = atof(GetFieldNoString(101));
    p2 = atof(GetFieldNoString(104));
    p3 = atof(GetFieldNoString(107));
    p4 = atof(GetFieldNoString(110));
    p5 = atof(GetFieldNoString(113));
    p6 = atof(GetFieldNoString(116));
    p7 = atof(GetFieldNoString(119));
    p8 = atof(GetFieldNoString(122));
    p9 = atof(GetFieldNoString(125));
    p10 = atof(GetFieldNoString(128));
    p11 = atof(GetFieldNoString(131));
    p12 = atof(GetFieldNoString(134));
    p13 = atof(GetFieldNoString(137));
    p14 = atof(GetFieldNoString(140));
    p15 = atof(GetFieldNoString(143));
    p16 = atof(GetFieldNoString(146));
    return p1+p2+p3+p4+p5+p6+p7+p8+p9+p10+p11+p12+p13+p14+p15+p16;
	*/
}

#ifdef ANSI
int GetPer13()
#else            
int GetPer13()
#endif
{
	/*	Code altered to use integers as double+double+double!=double*3
		because can't represent float values perfectly in binary*/

   

   int i=0;

  /* This function is used to obtain the sum of module record
     fields 014 SBJPER01, 017 SBJPER02, 023 SBJPER03, 026 SBJPER04.
     Remember that in the C code field numbers are zero-based.
 
    2005-03-03 MDE  rewritten to incorporate new fields SBJPER03 and 04.    
   WAS: 

	int i=0,iGSFieldNo = 13;
	while((iGSFieldNo < 17) && !IsEmpty(iGSFieldNo)){
		i +=  atoi(StripChar(GetFieldNoString(iGSFieldNo),'.'));
		iGSFieldNo +=3;         
		}

   */

   if (!IsEmpty(13)) i+=atoi(StripChar(GetField(13),'.'));
   if (!IsEmpty(16)) i+=atoi(StripChar(GetField(16),'.'));
   if (!IsEmpty(22)) i+=atoi(StripChar(GetField(22),'.'));
   if (!IsEmpty(25)) i+=atoi(StripChar(GetField(25),'.'));
    
	return i;
	
	/*double p1,p2;
    p1 = atof(GetFieldNoString(13));
    p2 = atof(GetFieldNoString(16));
	*/
}	
    
#ifdef ANSI
char *StripChar(char *term,char TakeOut)
#else            
char *StripChar()
char *term;                            
char TakeOut;
#endif
{        
	int iIndex=0;
	while(*(term+iIndex)){
		if(*(term+iIndex)==TakeOut)
			strcpy(term+iIndex,term+iIndex+1);
		iIndex++;
		}
	return term;

/*	int RSCount=0,RSPlace;
	static char RetString[40];
	for(RSPlace =0;RSPlace<40;RSPlace++) 
		RetString[RSPlace]='\0';

	while(*term){
		if(*term != TakeOut){
			RetString[RSCount]= *term;
			RSCount++;	     
			};
			term++;	
		}     
	strcat(RetString,"\0");
    return RetString; */
}    
#ifdef ANSI
int CheckTable(char *Item,char Table[][6])
#else
int CheckTable(Item, Table[][6] )       
char *Item;
char Table[][6];
#endif
{
	int TableIndex=0;
	while(*Table[TableIndex]){
	  if(!strcmp(Table[TableIndex],Item))
	     return 1;
	   TableIndex++;
	  }                                   
	return 0;     
}
#ifdef ANSI
int CheckTableDeFunct(int iFieldNo,struct DFQ Table[])
#else
int CheckTableDeFunct(iFieldNo, Table)       
int iFieldNo;
struct DFQ Table[];
#endif
{
	int TableIndex = 0;
	PSZ pszValue=NULL;
	
	pszValue=GetFieldNoString(iFieldNo);
    
	while(Table[TableIndex].iFieldNo){
	  if(Table[TableIndex].iFieldNo ==iFieldNo+1) 
	  	if(!strcmp(Table[TableIndex].ValidItem,pszValue))
	  	   return 1;
	    TableIndex++;
	  }                                   
 
	return 0;     
}          
#ifdef ANSI
int CountType(char* szLookIn ,char* LookForType)
#else                                          
int CountType(szLookIn ,LookForType)
char* szLookIn;
char* LookForType;                    
#endif
{    
/* LookForType either a group as in Alpha or  an actual string*/ 
	 int nItemsFound =0;
 	 if(!strcmp(LookForType,"Alpha")){
 	    while(*szLookIn){
 	        if(isalpha(*szLookIn++))
 	           nItemsFound++;
 	        }                        
 	    }
 	 else    
 	    while(strstr(szLookIn+nItemsFound,LookForType))
 	 	   nItemsFound++;
  	 
 	 return nItemsFound;   
} 	           

#ifdef ANSI
BOOL IsItALeapYear(unsigned int nYear)
#else                                          
BOOL  IsItALeapYear(nYear)
unsigned int nYear;
#endif
{   
	BOOL nLeapYear ;
	(nYear % 4 == 0 && nYear % 100 != 0) || nYear % 400 == 0 ? (nLeapYear=1) : (nLeapYear=0);	 
	 	return nLeapYear;
	  } 	           
